from z3 import *
set_param(proof=True)
try:
	CONRT_EtherStore= DeclareSort('CONRT_EtherStore')
	map= DeclareSort('map')
	EtherStore_balances= Function('EtherStore_balances',CONRT_EtherStore,map)
	EtherStore_votes= Function('EtherStore_votes',CONRT_EtherStore,map)
	address= DeclareSort('address')
	msg_sender= Const('msg_sender',address)
	d1FaddressTuint256mapping= Function('d1FaddressTuint256mapping',map,address,IntSort())
	bal= Int('bal')
	void= DeclareSort('void')
	_1solidity= Const('_1solidity',void)
	TUPLE= DeclareSort('TUPLE')
	TUPLE_0= Const('TUPLE_0',TUPLE)
	LOW_LEVEL_CALL_call= Function('LOW_LEVEL_CALL_call',address,IntSort(),TUPLE)
	sent= Const('sent',BoolSort())
	UNPACK2DTUPLETbool= Function('UNPACK2DTUPLETbool',TUPLE,IntSort(),BoolSort())
	_2solidity= Const('_2solidity',void)
	_1reentrancy_verifier= Int('_1reentrancy_verifier')
	_2reentrancy_verifier= Int('_2reentrancy_verifier')
	IsEtherStore= Function('IsEtherStore',CONRT_EtherStore,BoolSort())
	EtherStore_balances1= Function('EtherStore_balances1',CONRT_EtherStore,map)
	EtherStore_votes1= Function('EtherStore_votes1',CONRT_EtherStore,map)
	msg_sender1= Const('msg_sender1',address)
	d1FaddressTuint256mapping1= Function('d1FaddressTuint256mapping1',map,address,IntSort())
	bal1= Int('bal1')
	_1solidity1= Const('_1solidity1',void)
	TUPLE_01= Const('TUPLE_01',TUPLE)
	LOW_LEVEL_CALL_call1= Function('LOW_LEVEL_CALL_call1',address,IntSort(),TUPLE)
	sent1= Const('sent1',BoolSort())
	UNPACK2DTUPLETbool1= Function('UNPACK2DTUPLETbool1',TUPLE,IntSort(),BoolSort())
	_2solidity1= Const('_2solidity1',void)
	_1reentrancy_verifier1= Int('_1reentrancy_verifier1')
	_2reentrancy_verifier1= Int('_2reentrancy_verifier1')
	_y18= Const('_y18',CONRT_EtherStore)
	_y19= Const('_y19',CONRT_EtherStore)
	_y20= Const('_y20',address)
	_y21= Int('_y21')
	_y22= Const('_y22',TUPLE)
	_y23= Int('_y23')
	_y24= Const('_y24',map)
	_y25= Const('_y25',address)
	_y26= Const('_y26',CONRT_EtherStore)
	_y27= Const('_y27',CONRT_EtherStore)
	_y28= Const('_y28',CONRT_EtherStore)
	_y29= Const('_y29',CONRT_EtherStore)
	_y30= Const('_y30',CONRT_EtherStore)
	_y31= Const('_y31',CONRT_EtherStore)
	_y32= Const('_y32',CONRT_EtherStore)
	_y33= Const('_y33',CONRT_EtherStore)
	_y34= Const('_y34',CONRT_EtherStore)
	_s=Solver()
	_s.set("timeout",50000)
	_s.add(ForAll([_y18],EtherStore_balances1(_y18)==EtherStore_balances(_y18)))
	_s.add(ForAll([_y19],EtherStore_votes1(_y19)==EtherStore_votes(_y19)))
	_s.add(_1solidity1==_1solidity)
	_s.add(ForAll([_y20,_y21],LOW_LEVEL_CALL_call1(_y20,_y21)==LOW_LEVEL_CALL_call(_y20,_y21)))
	_s.add(ForAll([_y22,_y23],UNPACK2DTUPLETbool1(_y22,_y23)==UNPACK2DTUPLETbool(_y22,_y23)))
	_s.add(_2solidity1==_2solidity)
	_s.add(ForAll([_y24,_y25,_y26,msg_sender],d1FaddressTuint256mapping1(_y24,_y25)==If(((d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(And(((EtherStore_balances(_y26))==(EtherStore_votes(_y26))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender))),0),If(And(((_y24)==(EtherStore_balances(_y26))),((_y25)==(msg_sender))),0,If(((If(And(((EtherStore_balances(_y26))==(EtherStore_votes(_y26))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender)))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(And(((EtherStore_balances(_y26))==(EtherStore_votes(_y26))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender))),0),If(And(((_y24)==(EtherStore_balances(_y26))),((_y25)==(msg_sender))),0,If(And(((_y24)==(EtherStore_votes(_y26))),((_y25)==(msg_sender))),((If(And(((EtherStore_votes(_y26))==(EtherStore_votes(_y26))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender)))-(1)),If(And(((_y24)==(EtherStore_votes(_y26))),((_y25)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(_y24,_y25)))),If(And(((_y24)==(EtherStore_votes(_y26))),((_y25)==(msg_sender))),((If(And(((EtherStore_votes(_y26))==(EtherStore_votes(_y26))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender)))-(1)),If(And(((_y24)==(EtherStore_votes(_y26))),((_y25)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(_y24,_y25)))),If(And(((_y24)==(EtherStore_votes(_y26))),((_y25)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(_y24,_y25)))),If(((If(And(((EtherStore_balances(_y26))==(EtherStore_votes(_y26))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender)))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(And(((EtherStore_balances(_y26))==(EtherStore_votes(_y26))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y26),msg_sender))),0),If(And(((_y24)==(EtherStore_balances(_y26))),((_y25)==(msg_sender))),0,If(And(((_y24)==(EtherStore_votes(_y26))),((_y25)==(msg_sender))),((If(And(((EtherStore_votes(_y26))==(EtherStore_votes(_y26))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender)))-(1)),If(And(((_y24)==(EtherStore_votes(_y26))),((_y25)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(_y24,_y25)))),If(And(((_y24)==(EtherStore_votes(_y26))),((_y25)==(msg_sender))),((If(And(((EtherStore_votes(_y26))==(EtherStore_votes(_y26))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender)))-(1)),If(And(((_y24)==(EtherStore_votes(_y26))),((_y25)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(_y24,_y25)))),If(And(((_y24)==(EtherStore_votes(_y26))),((_y25)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y26),msg_sender))-(1)),d1FaddressTuint256mapping(_y24,_y25)))),d1FaddressTuint256mapping(_y24,_y25))))
	_s.add(ForAll([_y27,msg_sender],bal1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y27),msg_sender))>(0)),If(And(((EtherStore_balances(_y27))==(EtherStore_votes(_y27))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y27),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y27),msg_sender)),d1FaddressTuint256mapping(EtherStore_balances(_y27),msg_sender))))
	_s.add(ForAll([_y28,msg_sender],TUPLE_01==If(((d1FaddressTuint256mapping(EtherStore_balances(_y28),msg_sender))>(0)),LOW_LEVEL_CALL_call(msg_sender,If(And(((EtherStore_balances(_y28))==(EtherStore_votes(_y28))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y28),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y28),msg_sender))),TUPLE_0)))
	_s.add(ForAll([_y29,msg_sender],sent1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y29),msg_sender))>(0)),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(And(((EtherStore_balances(_y29))==(EtherStore_votes(_y29))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y29),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y29),msg_sender))),0),sent)))
	_s.add(ForAll([_y30,msg_sender],_1reentrancy_verifier1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y30),msg_sender))>(0)),1,0)))
	_s.add(ForAll([_y31,msg_sender],_2reentrancy_verifier1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y31),msg_sender))>(0)),If(((If(And(((EtherStore_balances(_y31))==(EtherStore_votes(_y31))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y31),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y31),msg_sender)))>(0)),1,0),0)))
	_s.add(ForAll([_y32,msg_sender],((d1FaddressTuint256mapping(EtherStore_balances(_y32),msg_sender))>(0))))
	_s.add(ForAll([_y33],Not(((EtherStore_balances(_y33))==(EtherStore_votes(_y33))))))
	_s.add(ForAll([_y34],Not(((EtherStore_votes(_y34))==(EtherStore_balances(_y34))))))
	_s.add(Not(And((_1reentrancy_verifier1==1),(_2reentrancy_verifier1==1))))
except Exception as e:
	print("Error1(Z3Query)"+str(e))
	sys.exit(1)
try:
	result=_s.check()
	if sat==result:
		print("Counter Example")
		print (_s.model())
	elif unsat==result:
		print ("Successfully Proved")
	else:
		print("Failed To Prove")
except Exception as e:
	print("Error2(Z3Query)"+str(e))
	sys.exit(1)